grammar calc2;

@header {
import java.lang.Integer;
import java.lang.Math;
}

calc
	: lines EOF
	;
	
lines
	: (line NL)+
	;

line
	: expr {System.out.println($expr.value);}
	;

expr returns [int value]
	: t1=term {$value = $t1.value;} (PLUS t2=term {$value += $t2.value;} | MINUS t2=term {$value -= $t2.value;})*
	;

term returns [int value]
	: f1=factor {$value = $f1.value;} (MULT f2=factor {$value *= $f2.value;} | DIV f2=factor {$value /= $f2.value;})*
	;
	
factor returns [int value]
	: PLUS f1=factor {$value = $f1.value;}
	| MINUS f2=factor {$value = -$f2.value;}
	| atom {$value = $atom.value;}
	;

atom returns [int value]
	: INT {$value = Integer.parseInt($INT.text);}
	| PI {$value = 3;}
	| E {$value = 2;}
	| LPAR expr RPAR {$value = $expr.value;}
	;

PI
	: 'PI'
	;

E
	: 'E'
	;
	
INT
	: '0'..'9'+
	;

PLUS
	: '+'
	;
	
MINUS
	: '-'
	;
	
MULT
	: '*'
	;
	
DIV
	: '/'
	;

LPAR
    : '('
    ;

RPAR
    : ')'
    ;

NL
	: '\r'|'\n'
	;

WHITESPACE
	: ('\t'|' '|'\u000C')+ {$channel = HIDDEN;}
	;
